diff --git a/meta/recipes-support/nss/nss/0001-Fix-warnings-found-with-gcc7.patch b/meta/recipes-support/nss/nss/0001-Fix-warnings-found-with-gcc7.patch
new file mode 100644
index 00000000000..b16fb020c1c
--- /dev/null
+++ b/meta/recipes-support/nss/nss/0001-Fix-warnings-found-with-gcc7.patch
@@ -0,0 +1,41 @@
+From a1d2ef6a8e1bc721e44640bdb85747deaf8edcca Mon Sep 17 00:00:00 2001
+From: Khem Raj <raj.khem@gmail.com>
+Date: Wed, 19 Apr 2017 10:50:37 -0700
+Subject: [PATCH] Fix warnings found with gcc7
+
+GCC7 finds more type conversion issues
+
+| pkix_pl_ocsprequest.c: In function 'pkix_pl_OcspRequest_Hashcode':
+| pkix_pl_ocsprequest.c:92:60: error: '<<' in boolean context, did you mean '<' ? [-Werror=int-in-bool-context]
+|          *pHashcode = (((((extensionHash << 8) || certHash) << 8) ||
+|                         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~
+| pkix_pl_ocsprequest.c:93:27: error: '<<' in boolean context, did you mean '<' ? [-Werror=int-in-bool-context]
+|          *pHashcode = (((((extensionHash << 8) || certHash) << 8) ||
+|                       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+|                  dateHash) << 8) || signerHash;
+|                  ~~~~~~~~~~^~~~~
+| cc1: all warnings being treated as errors
+
+Upstream-Status: Pending
+
+Signed-off-by: Khem Raj <raj.khem@gmail.com>
+---
+ nss/lib/libpkix/pkix_pl_nss/pki/pkix_pl_ocsprequest.c | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/nss/lib/libpkix/pkix_pl_nss/pki/pkix_pl_ocsprequest.c b/nss/lib/libpkix/pkix_pl_nss/pki/pkix_pl_ocsprequest.c
+index 171a3d2..d5eef88 100644
+--- a/nss/lib/libpkix/pkix_pl_nss/pki/pkix_pl_ocsprequest.c
++++ b/nss/lib/libpkix/pkix_pl_nss/pki/pkix_pl_ocsprequest.c
+@@ -89,7 +89,7 @@ pkix_pl_OcspRequest_Hashcode(
+         PKIX_HASHCODE(ocspRq->signerCert, &signerHash, plContext,
+                 PKIX_CERTHASHCODEFAILED);
+ 
+-        *pHashcode = (((((extensionHash << 8) || certHash) << 8) ||
++        *pHashcode = ((PKIX_UInt32)(((PKIX_UInt32)((extensionHash << 8) || certHash) << 8) ||
+                 dateHash) << 8) || signerHash;
+ 
+ cleanup:
+-- 
+2.12.2
+
diff --git a/meta/recipes-support/nss/nss_3.28.1.bb b/meta/recipes-support/nss/nss_3.29.1.bb
similarity index 90%
rename from meta/recipes-support/nss/nss_3.28.1.bb
rename to meta/recipes-support/nss/nss_3.29.1.bb
index fed86fc8e92..48db0312b10 100644
--- a/meta/recipes-support/nss/nss_3.28.1.bb
+++ b/meta/recipes-support/nss/nss_3.29.1.bb
@@ -14,20 +14,20 @@ LIC_FILES_CHKSUM = "file://nss/COPYING;md5=3b1e88e1b9c0b5a4b2881d46cce06a18 \
                     file://nss/lib/freebl/mpi/doc/LICENSE;md5=491f158d09d948466afce85d6f1fe18f \
                     file://nss/lib/freebl/mpi/doc/LICENSE-MPL;md5=5d425c8f3157dbf212db2ec53d9e5132"
 
-SRC_URI = "\
-    http://ftp.mozilla.org/pub/mozilla.org/security/nss/releases/NSS_3_28_1_RTM/src/${BP}.tar.gz \
-    file://0001-nss-fix-support-cross-compiling.patch \
-    file://nss-no-rpath-for-cross-compiling.patch \
-    file://nss-fix-incorrect-shebang-of-perl.patch \
-    file://nss-fix-nsinstall-build.patch \
-    file://disable-Wvarargs-with-clang.patch \
-    file://pqg.c-ULL_addend.patch \
-    file://Fix-compilation-for-X32.patch \
-    file://nss.pc.in \
-    file://signlibs.sh \
-"
-SRC_URI[md5sum] = "e98d48435cee5792f97ef7fc35a602c3"
-SRC_URI[sha256sum] = "58cc0c05c0ed9523e6d820bea74f513538f48c87aac931876e3d3775de1a82ad"
+SRC_URI = "http://ftp.mozilla.org/pub/mozilla.org/security/nss/releases/NSS_3_29_1_RTM/src/${BP}.tar.gz \
+           file://nss.pc.in \
+           file://signlibs.sh \
+           file://0001-nss-fix-support-cross-compiling.patch \
+           file://nss-no-rpath-for-cross-compiling.patch \
+           file://nss-fix-incorrect-shebang-of-perl.patch \
+           file://nss-fix-nsinstall-build.patch \
+           file://disable-Wvarargs-with-clang.patch \
+           file://pqg.c-ULL_addend.patch \
+           file://Fix-compilation-for-X32.patch \
+           file://0001-Fix-warnings-found-with-gcc7.patch \
+           "
+SRC_URI[md5sum] = "0525d1a45931892daa0f368d379d4aa4"
+SRC_URI[sha256sum] = "47259bc5c4439d8228d7c577ea652ed140588f27eae8ebb39cc91057aea37366"
 
 UPSTREAM_CHECK_URI = "https://developer.mozilla.org/en-US/docs/Mozilla/Projects/NSS/NSS_Releases"
 UPSTREAM_CHECK_REGEX = "NSS_(?P<pver>.+)_release_notes"